﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Net.Sockets;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace WpfApp2
{
    /// <summary>
    /// MainWindow.xaml에 대한 상호 작용 논리
    /// </summary>
    public partial class MainWindow : Window
    {
        #region 전역변수
        private const int buffSize = 65535;
        private StateObject state = new StateObject();
        private CancellationTokenSource source = new CancellationTokenSource();
        private Socket socket;
        private EndPoint ep = new IPEndPoint(IPAddress.Any, 0);
        private AsyncCallback recv = null;
        public IPEndPoint RemoteEndPoint;
        Task send_task;
        private bool b_heartBeatThread;
        #endregion

        public class StateObject
        {
            public byte[] buffer = new byte[buffSize];
        }

        public MainWindow()
        {
            InitializeComponent();

            Connected(ipNumber.Text, Int32.Parse(portNumber.Text));
        }

        private void Connect_Click(object sender, RoutedEventArgs e)
        {
            Connected(ipNumber.Text, Int32.Parse(portNumber.Text));
        }

        private void DisConnect_Click(object sender, RoutedEventArgs e)
        {
            b_heartBeatThread = false;
            send_task.Wait();
            send_task = null;
            source.Cancel();
            socket.Close();
            //socket = null;
        }

        public int Connected(string ipNumber, int portNumber)
        {
            IPAddress ipAddress;

            if(IPAddress.TryParse(ipNumber, out ipAddress))
            {
                RemoteEndPoint = new IPEndPoint(ipAddress, portNumber);
                socket = new Socket(AddressFamily.InterNetwork, SocketType.Dgram, ProtocolType.Udp);
                socket.Connect(RemoteEndPoint);
                b_heartBeatThread = true;
            }

            send_task = new Task(new Action<object>(HeartBeatThread), socket, source.Token);
            // 질문 : 왜 두번째 실행 때 HeartBeatThread가 null인가요??
            send_task.Start();

            return 0;
        }

        public void HeartBeatThread(object socket)
        {
            if (socket == null) return;
            Thread.Sleep(1000);
            string startData = "START";
            int dataSize = startData.Length;

            while (b_heartBeatThread)
            {
                Send(RemoteEndPoint, Encoding.UTF8.GetBytes(startData));
                Thread.Sleep(900);
            }
        }

        internal void Send(IPEndPoint endPoint, byte[] data)
        {
            socket.BeginSendTo(data, 0, data.Length, SocketFlags.None, endPoint, (ar) =>
            {
                StateObject so = (StateObject)ar.AsyncState;
                int bytes = socket.EndSend(ar);
            }, state);
        }
    }
}
